var queryString_ = null;
var encoding_ = '';

Widget = Class.create();
Widget.preferenceForKey = function(key)
{
    return widget.preferenceForKey(widget.identifier + '-' + key)
};

Widget.setPreferenceForKey = function(value, key)
{
    widget.setPreferenceForKey(value, widget.identifier + '-' + key)
};

function setup()
{    
    widget.onshow = onshow;
    widget.onremove = onremove;
    
    Element.show('front');
    Element.hide('back');

    var s;
    
    s = Widget.preferenceForKey('title') || 'CQCC';
    setLogoTitle(s);
    $('title').value = s;

    queryString_ = Widget.preferenceForKey('query') || 'http://www.google.com/search?&q=$0';
    $('query').value = queryString_;

    encoding_ = Widget.preferenceForKey('encoding') || '';
    setEncoding(encoding_);

    createGenericButton($('doneButton'), 'Done', doneClicked);
    createGenericButton($('okButton'), 'Ok', okClicked);
    createGenericButton($('ccButton'), 'Cc!',
                        function () {
                            Element.hide('prefs', 'ccButton', 'doneButton');
                            Element.show('publish', 'okButton', 'cancelButton');
                        });
    createGenericButton($('cancelButton'), 'Cancel', switchToPrefs);

    flip_.button = $('flip');
    flip_.rollie = $('flip-rollie');
    flip_.beforeBack = function() {
        if (typeof PUBLISHED != 'undefined') {
            Element.hide('backContent', 'backBottom');
            return;
        }
        
        $('backContent').style.height = 100 + 'px';
        $('backBottom').style.top = 100 + 50 + 'px';
        
        window.resizeTo(250, 200);
        
        Element.show('prefs', 'ccButton', 'doneButton');        
        Element.hide('publish', 'okButton', 'cancelButton');
    }

    if (typeof PUBLISHED != 'undefined') {
        queryString_ = QUERY_STRING;
        encoding_ = ENCODING;
        setLogoTitle(TITLE);
        setCreatorCredit(CREATOR_NAME, ADDRESS);
    } else {
        Element.hide('return');
    }
}

function onshow()
{
}

function encodeURI(s, encoding)
{
    if (encoding_ != '') {
        return widget.system("./CQCC.rb encode " + encoding_ + " '" + s + "'", null).outputString;
    } else {
        return s;
    }
}

function search(word)
{
    var s;
    
    s = $('searchField').value;
    var ary = s.split(/ +/);
    ary.unshift(s);
    
    s = queryString_;
    for (var i = 0; i < 10; i++) {
        s = s.replace('$'+i, encodeURI(ary[i] || '', encoding_));
    }

    widget.openURL(s);
    
    $('searchField').value = '';
}

function okClicked()
{
    widget.system("./CQCC.rb create '" +
                  $('title').value + "' '" +
                  queryString_ + "' '" +
                  encoding_ + "' '" +
                  $('name').value + "' '" +
                  $('address').value + "' '" +
                  $('identifier').value + "'", null);
    
    switchToPrefs();
}

function doneClicked()
{
    flip_.toFront();

    if (typeof PUBLISHED != 'undefined') {
        ;
    } else {
        window.resizeTo(250, 50);
        
        setLogoTitle($('title').value);
        queryString_ = $('query').value;
        
        Widget.setPreferenceForKey($('title').value, 'title');
        Widget.setPreferenceForKey(queryString_, 'query');
        Widget.setPreferenceForKey(encoding_, 'encoding');
    }
}

function switchToPrefs()
{
    Element.show('prefs', 'ccButton', 'doneButton');        
    Element.hide('publish', 'okButton', 'cancelButton');
}

function setLogoTitle(s)
{
    $('logo').innerText = s;
    
    $('searchField').style.left = $('logo').offsetWidth + 12 + 'px';
    $('searchField').style.width = 250 - ($('logo').offsetWidth + 40) + 'px';
}

function setEncoding(s)
{
    var ary = $('encoding').options;
    for (var i = 0; i < ary.length; i++) {
        if (ary[i].value == s) {
            $('encoding').selectedIndex = i;
            break;
        }
    }
}

function setCreatorCredit(name, address)
{
    $('credit').innerHTML = ('Created by <a onclick="widget.openURL(\'' +
                             address + '\')">' + name + '</a> with ' +
                             '<a onclick="widget.openURL(\'http://8-p.info/CQCC/\')">CQCC</a>');
                             
}

function onremove()
{
    Widget.setPreferenceForKey(null, 'title');
    Widget.setPreferenceForKey(null, 'query');
}
