#! /usr/bin/env ruby
case ARGV.shift
when 'encode'
  require 'iconv'
  require 'cgi'

  while line = gets
    puts CGI.escape(Iconv.conv(ARGV.shift, 'UTF-8-MAC', line.chomp))
  end
when 'create'
  title = ARGV.shift
  query_string = ARGV.shift
  encoding = ARGV.shift
  creator_name = ARGV.shift
  address = ARGV.shift
  identifier = ARGV.shift
  
  dst_path = File.expand_path("~/Desktop/#{title}.wdgt")
  
  # Copy
  require 'fileutils'
  FileUtils.cp_r('.', dst_path)

  # Write local.js
  open("#{dst_path}/local.js", 'w') do |io|
    io.print(<<END)
PUBLISHED = true;

TITLE = '#{title}';
QUERY_STRING = '#{query_string}';
ENCODING = '#{encoding}';
CREATOR_NAME = '#{creator_name}';
ADDRESS = '#{address}';

END
  end
  
  # Write Info.plist
  require 'erb'
  open("#{dst_path}/Info.plist", 'w') do |io|
    tmpl = ERB.new(File.read('Info.plist.in'))
    io.print(tmpl.result(binding))
  end

  # Open Widget
  # system("open #{dst_path}")
else
  exit(1)
end
