/*
  Copyright (C) 2005 KATO Kazuyoshi <kzys@8-p.info>
      All rights reserved.
      This is free software with ABSOLUTELY NO WARRANTY.

  This file is released under the terms of the MIT X11 license.
*/

Flip = Class.create();

Flip.prototype = {
    button: null,
    rollie: null,
    beforeBack: function() {},
    
    duration: 0,
    startTime: 0.0,
    timer: null,
    
    opacity: 0.0,
    startOpacity: 1.0,
    endOpacity: 0.0,

    
    initialize: function() {
    },

    toBack: function() {
        this.beforeBack();

        if (window.widget) {
            widget.prepareForTransition("ToBack");
        }

        Element.hide('front');
        Element.show('back');

        if (window.widget) {
            setTimeout('widget.performTransition();', 1);
        }
    },

    toFront: function() {
        if (window.widget)
            widget.prepareForTransition("ToFront");
        
        Element.hide('back');
        Element.show('front');
        
        if (window.widget)
            setTimeout ('widget.performTransition();', 0);
    },

    mousemove: function(event) {
        if (this.timer) {
            clearInterval(this.timer);
            this.timer = null;
        }

        var count = 15;
        
        this.duration = 500;
        this.startTime = (new Date).getTime() - count;
        
        this.startOpacity = this.opacity;
        this.endOpacity = 1.0;
        
        this.timer = setInterval(this.animate.bind(this), count);
    },

    mouseout: function(event) {
        if (this.timer) {
            clearInterval(this.timer);
            this.timer = null;
        }

        var count = 13;

        this.duration = 500;
        this.startTime = (new Date).getTime() - count;
        
        this.startOpacity = this.opacity;
        this.endOpacity   = 0.0;
        
        this.timer = setInterval(this.animate.bind(this), count);
    },

    enter: function(event) {
        this.rollie.style.display = 'block';
    },

    exit: function(event) {
        this.rollie.style.display = 'none';
    },

    animate: function() {
        var time = (new Date).getTime();
        var t = this.limit3(time - this.startTime, 0, this.duration);

        if (t >= this.duration) {
            clearInterval(this.timer);
            this.timer = null;
            this.opacity = this.endOpacity;
        } else {
            var ease = 0.5 - (0.5 * Math.cos(Math.PI * t / this.duration));
            this.opacity = this.computeNextFloat(this.startOpacity, this.endOpacity, ease);
        }

        this.button.style.opacity = this.opacity;
    },

    limit3: function(a, b, c) {
        return a < b ? b : (a > c ? c : a);
    },

    computeNextFloat: function(from, to, ease) {
        return from + (to - from) * ease;
    }

};
